SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'HernanWilkinson 4/25/2011 17:22'!
canNotConvertMeasurementException
	
	self error: 'Este metodo debe devolver el objeto que representa que no se pudo
		convertir una medida a la unidad pedida'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'JuanIgnacio 5/22/2013 19:05'!
celsius
	
	^ TemperatureUnit new celsius.! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:06'!
centimeter
	
	^ DistanceUnit new centimeter.! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanIgnacio 5/22/2013 19:06'!
day
	
	^ TimeUnit new day.! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:06'!
decameter
	
	^DistanceUnit new decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:06'!
decimeter
	
	^DistanceUnit new decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
eightCubicMeters

	^self error: 'este metodo debe devolver la medida 8 metros cubicos'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'JuanIgnacio 5/22/2013 19:06'!
fahrenheit
	
	^TemperatureUnit new fahrenheit.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
fourSquaredMeters

	^self error: 'este metodo debe devolver la medida 4 metros cuadrados'! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
hectometer
	
	^DistanceUnit new hectometer.! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
hour
	
	^TimeUnit new hour.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
kelvin
	
	^TemperatureUnit new kelvin.! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
kilometer
	
	^DistanceUnit new  kilometer.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
meter

	^DistanceUnit new meter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
millimeter
	
	^DistanceUnit new  millimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 16:03'!
minusOneMeter 
	
	self error: 'Este metodo debe devolver un objeto que represente un metro'! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanIgnacio 5/22/2013 19:07'!
minute
	
	^TimeUnit new minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanIgnacio 5/22/2013 19:08'!
oneCelsius
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TemperatureUnit new.
	newUnit celsius.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 21:50'!
oneCentimeter
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit centimeter.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
oneDay
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit day.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
oneHour

	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit hour.
	measureToReturn  := Measure createWithQuantity: 1  andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 21:49'!
oneHundredCentimeters
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit centimeter.
	measureToReturn  := Measure createWithQuantity: 100 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 21:37'!
oneMeter
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit meter.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneMeterPerSecond

	^self error: 'este metodo debe devolver la medida 1 metro/segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
oneMinute
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit minute.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.
	! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
oneSecond
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit second.
	measureToReturn  := Measure createWithQuantity: 1 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:37'!
oneSquaredMeter

	^self error: 'este metodo debe devolver la medida 1 metro cuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneSquaredSecond

	^self error: 'este metodo debe devolver la medida 1 segundo cuadrado'! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanIgnacio 5/22/2013 19:12'!
second
	
	^TimeUnit new second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
sixtyMinutes
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit minute.
	measureToReturn  := Measure createWithQuantity: 60andUnit: newUnit .
	^measureToReturn.
	! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
sixtyOneSeconds
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit minute.
	measureToReturn  := Measure createWithQuantity: 61 andUnit: newUnit .
	^measureToReturn.
	! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
sixtySeconds
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit second.
	measureToReturn  := Measure createWithQuantity: 60 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'JuanIgnacio 5/20/2013 21:39'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'JuanIgnacio 5/20/2013 21:48'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'."SUBCLASIFY DIFFERENTUNITS porque los calculos de amount son distintos"
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanIgnacio 5/22/2013 19:29'!
thirtyTwoFahrenheits
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TemperatureUnit new.
	newUnit fahrenheit.
	measureToReturn  := Measure createWithQuantity: 32 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
twentyFourHours
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit hour.
	measureToReturn  := Measure createWithQuantity: 24 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanIgnacio 5/22/2013 19:15'!
twoCelsius
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit  new.
	newUnit celsius.
	measureToReturn  := Measure createWithQuantity: 2 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 21:50'!
twoHundredCentimeters
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit centimeter.
	measureToReturn  := Measure createWithQuantity: 200 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 21:50'!
twoMeters
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit meter.
	measureToReturn  := Measure createWithQuantity: 2 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
twoMetersBySecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundo'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersPerSquaredSecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersTimesSecond

	^self error: 'este metodo debe devolver la medida 2 metros*segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 21:51'!
twoSeconds
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit second.
	measureToReturn  := Measure createWithQuantity: 2 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanIgnacio 5/22/2013 19:16'!
zeroCelsius
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TemperatureUnit new.
	newUnit celsius.
	measureToReturn  := Measure createWithQuantity: 0 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanIgnacio 5/22/2013 19:16'!
zeroKelvin
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TemperatureUnit new.
	newUnit kelvin.
	measureToReturn  := Measure createWithQuantity: 0 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanIgnacio 5/22/2013 19:17'!
zeroMeters

	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := DistanceUnit new.
	newUnit meter.
	measureToReturn  := Measure createWithQuantity: 0 andUnit: newUnit .
	^measureToReturn.! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanIgnacio 5/22/2013 19:17'!
zeroSeconds
	
	| measureToReturn newUnit |
	measureToReturn := Measure new.
	newUnit := TimeUnit new.
	newUnit second.
	measureToReturn  := Measure createWithQuantity: 0 andUnit: newUnit .
	^measureToReturn.! !

Object subclass: #Measure
	instanceVariableNames: 'quantity unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:44'!
aDistanceMeasureWithAmount: aNumber 
	| aUnit |
	aUnit := Unit new.
	aUnit := aUnit meter .
	^ self createWithQuantity: aNumber andUnit: aUnit. 


! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 20:48'!
createWithQuantity: aQuantity andUnit: aUnit
	| aTemporaryDistanceMeasure |
	aTemporaryDistanceMeasure :=  self new.
	^aTemporaryDistanceMeasure initializeWithQuantity: aQuantity andUnit: aUnit.
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
* aScalar 
	^ Measure createWithQuantity: ( self quantity * aScalar ) andUnit: (self unit ) 
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
+ aDistanceMeasure 
	^ Measure createWithQuantity: (self quantity + aDistanceMeasure quantity) andUnit: self unit 
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
- aDistanceMeasure 
	^ Measure createWithQuantity: (self quantity - aDistanceMeasure quantity) andUnit: self unit 
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
/ anInteger
	^ Measure createWithQuantity: (self quantity / anInteger) andUnit: self unit 
	
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 19:48'!
< aDistanceMeasure 
	^self quantity < aDistanceMeasure quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 19:50'!
<= aDistanceMeasure 
	^self quantity <= aDistanceMeasure quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:48'!
= aMeasure
	( (aMeasure isKindOf: Measure ) and: ( aMeasure  unit isMemberOf:  self unit class )  ) ifTrue: [^  (self unit convertQuantity: self quantity) = (aMeasure unit convertQuantity: aMeasure quantity) ].
	^false! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 19:49'!
> aDistanceMeasure 
	^self quantity > aDistanceMeasure quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 19:50'!
>= aDistanceMeasure 
	^self quantity >= aDistanceMeasure quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:40'!
amount
	^quantity! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 17:44'!
between: aDistanceMeasure and: anotherDistanceMeasure
	 ^self quantity between: aDistanceMeasure quantity and: anotherDistanceMeasure quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 17:44'!
by: aDistanceMeasureInterval 
	^self.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 20:54'!
compareWith: aDistanceMeasure By: aIntegerCompareMethod

"^ self quantity aIntegerCompareMethod aDistanceMeasure quantity. "! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:40'!
convertTo: aUnit 
	self initializeWithQuantity: (aUnit conversionMethod value: quantity) andUnit: aUnit. ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 19:56'!
convertUnitTo: aUnit
| measureToReturn newQuantity |
measureToReturn := Measure new.
newQuantity := aUnit convertQuantity:self.
measureToReturn initializeWithQuantity:newQuantity andUnit: aUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 19:26'!
hash
	^quantity.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 19:43'!
initialize 
	quantity := 0! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/13/2013 20:46'!
initializeWithQuantity:aQuantity andUnit: aUnit
	quantity := aQuantity.
	unit:= aUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
max: aDistanceMeasure 
	| aTemporaryMeasure |
	aTemporaryMeasure := Measure new.
	aTemporaryMeasure initializeWithQuantity: (self quantity max: aDistanceMeasure quantity ) andUnit: self unit. 
	^aTemporaryMeasure.
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
meter: aQuantity 
	^(Measure  new) setQuantity: aQuantity * 1000! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
min: aDistanceMeasure 
	| aTemporaryMeasure |
	aTemporaryMeasure := Measure new.
	aTemporaryMeasure initializeWithQuantity: (self quantity min: aDistanceMeasure quantity ) andUnit: self unit. 
	^aTemporaryMeasure.
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 19:59'!
negated
	
	self initializeWithQuantity:  -1 * (self quantity) andUnit: self unit. ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:10'!
printString
	| stringToPrint |
	stringToPrint  := (self quantity )asString , ' ',(unit name) asPluralBasedOn: (self quantity) . 
	(stringToPrint endsWith: 'ss') ifTrue: [^ stringToPrint copyFrom: 1 to: (stringToPrint size - 1)].
	^stringToPrint .
	
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 19:42'!
quantity
	^quantity! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:20'!
to: aDistanceMeasure 
	^MeasureInterval initializeFrom: self to: aDistanceMeasure.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:20'!
to: aDistanceMeasure by: anotherDistanceMeasure

^ MeasureInterval initializeFrom: self to: aDistanceMeasure by: anotherDistanceMeasure.

! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 21:16'!
unit
^unit! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'from to iterationStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 18:27'!
initializeFrom: aDistanceMeasure To: aSecondDistanceMeasure by: anotherDistanceMeasure

| newDistanceInterval |
newDistanceInterval := self new.
^newDistanceInterval initializeTo: aDistanceMeasure by: anotherDistanceMeasure .! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:20'!
initializeFrom: aDistanceMeasure to: anotherDistanceMeasure
	| aTemporalDistanceMeasureInterval |
	aTemporalDistanceMeasureInterval := MeasureInterval new.
	^aTemporalDistanceMeasureInterval initializeFrom: aDistanceMeasure to: anotherDistanceMeasure.
	

	! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 18:28'!
initializeFrom: aDistanceMeasure to: aSecondDistanceMeasure by: anotherDistanceMeasure

| newDistanceInterval |
newDistanceInterval := self new.
^newDistanceInterval initializeFrom: aDistanceMeasure to: aSecondDistanceMeasure by: anotherDistanceMeasure .! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 18:13'!
initializeTo: aDistanceMeasure by: anotherDistanceMeasure

| newDistanceInterval |
newDistanceInterval := self new.
^newDistanceInterval initializeTo: aDistanceMeasure by: anotherDistanceMeasure .! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 20:07'!
by
	
	^ self iterationStep by:self.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
do: aClosure 
	| iterations limit value|
	iterations := 0.
	limit := (((self to amount) - (self from amount))  / (self iterationStep amount)) + 1 .

		value := 1.
	[ iterations < limit ] whileTrue: [  
		aClosure value: (Measure aDistanceMeasureWithAmount: value) .
		
		iterations := iterations + 1.
		value := value + self iterationStep amount.		
	  ]
! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 17:31'!
from
	^ from! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:20'!
initializeFrom: aDistanceMeasure to: anotherDistanceMeasure
	from := aDistanceMeasure.
	to := anotherDistanceMeasure.
	iterationStep  := NullMeasure new.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 20:05'!
initializeFrom: aDistanceMeasure to: aSecondDistanceMeasure by: anotherDistanceMeasure
	from := aDistanceMeasure.
	to := aSecondDistanceMeasure.
	iterationStep  := anotherDistanceMeasure .! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 20:07'!
iterationStep
^ iterationStep.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 18:30'!
size 
^5! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 17:31'!
to
	^ to! !

Object subclass: #NullMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullMeasure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/15/2013 20:09'!
amount
	 ^1! !

!NullMeasure methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/20/2013 20:17'!
by: aDistanceMeasureInterval

^Measure createWithQuantity: aDistanceMeasureInterval  from unit base andUnit: (aDistanceMeasureInterval  from) unit

! !

Object subclass: #Unit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #DistanceUnit
	instanceVariableNames: 'conversionMethod name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:41'!
= aUnit 
^self name= aUnit name.
! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:36'!
centimeter
	name:='centimeter'.
	conversionMethod := [:aQuantity | aQuantity  / 100]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 22:40'!
conversionMethod
	^conversionMethod.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:08'!
convertQuantity: aQuantity 
^ conversionMethod  value: aQuantity.! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:00'!
decameter
	name:='decameter'.
	conversionMethod := [:aQuantity | aQuantity  / 10]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:32'!
decimeter
	name:='decimeter'.
	conversionMethod := [:aQuantity | aQuantity * 10 ]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:00'!
hectometer
	name:='hectometer'.
	conversionMethod := [:aQuantity | aQuantity / 100 ]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:28'!
kilometer
	name:='kilometer'.
	conversionMethod := [:aQuantity | aQuantity / 1000]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 23:32'!
meter
	name:='meter'.
	conversionMethod := [:aQuantity | aQuantity]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 22:44'!
millimeter
	name:='millimeter'.
	conversionMethod := [:aQuantity | aQuantity * 1000]! !

!DistanceUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:53'!
printString
	^name! !

Unit subclass: #TemperatureUnit
	instanceVariableNames: 'conversionMethod name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 22:34'!
= aUnit 
(aUnit isMemberOf:  self class)ifTrue:[^ self name  =  aUnit name ].
^ false! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/24/2013 22:09'!
celsius
	name := 'celsius'.
	conversionMethod := [:aQuantity | aQuantity  ]! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:09'!
convertQuantity: aQuantity 
^ conversionMethod  value: aQuantity.! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 19:47'!
convertTemperatureTo: aUnit 

! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:54'!
fahrenheit
	name := 'fahrenheit'.
	conversionMethod := [:aQuantity | (aQuantity - 32) * (5/9) ]! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 20:04'!
isCelsius
	^self name = 'celsiu'.! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 20:04'!
isFahrenheit
^ self name = 'fahrenheit'! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 20:06'!
isKelvin
	^ name = 'kelvin'.! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:54'!
kelvin
	name := 'kelvin'.
	conversionMethod  := [ :aQuantity | aQuantity + 273 ].! !

!TemperatureUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:53'!
printString
	^name! !

Unit subclass: #TimeUnit
	instanceVariableNames: 'conversionMethod name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:42'!
= aUnit 
^self name = aUnit name.
! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:28'!
convertQuantity: aQuantity 
	^ conversionMethod value: aQuantity.! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:27'!
day
	name:='day'.
	conversionMethod := [:aQuantity | aQuantity  *24 * 60 *60 * 1000]! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:27'!
hour
	name := 'hour'.
	conversionMethod := [:aQuantity | aQuantity  * 60 *60 * 1000]! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:28'!
minute
	name := 'minute'.
	conversionMethod := [:aQuantity | aQuantity  * 60 * 1000]! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:53'!
printString
	^name! !

!TimeUnit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:28'!
second
	name := 'second'.
	conversionMethod := [:aQuantity | aQuantity * 1000 ]! !

!Unit methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/22/2013 21:53'!
printString 
	^self subclassResponsibility ! !
